
type t = {
    cons   : int -> t; 
    decons : unit -> ((int * t) option);
    length : unit -> int
  } 

let rec cons_f i l =
  let rec r = 
  { cons   = (fun j  -> cons_f j r);
    decons = (fun () -> Some (i,l));
    length = (fun () -> 1 + l.length ())
  } in
  r

let mt_list1 =
  let rec r = 
  { cons   = (fun j  -> cons_f j r);
    decons = (fun () -> None);
    length = (fun () -> 0)
  } in
  r

let rec make l =
  let len = List.length l in
  { cons   = (fun i  -> make (i::l));
    decons = (fun () -> match l with [] -> None | hd::tl -> Some(hd,make tl));
    length = (fun () -> len)
  } 

let mt_list2 = make []

